package com.hai.dao;

import com.hai.entity.ApiRequestRecord;
import com.hai.entity.ApiRequestRecordExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface ApiRequestRecordMapper extends ApiRequestRecordMapperExt {
    @SelectProvider(type=ApiRequestRecordSqlProvider.class, method="countByExample")
    long countByExample(ApiRequestRecordExample example);

    @DeleteProvider(type=ApiRequestRecordSqlProvider.class, method="deleteByExample")
    int deleteByExample(ApiRequestRecordExample example);

    @Delete({
        "delete from api_request_record",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into api_request_record (api_key, mch_id, ",
        "request_params, request_describe, ",
        "create_time, request_status, ",
        "`status`, ext_1, ext_2, ",
        "ext_3)",
        "values (#{apiKey,jdbcType=VARCHAR}, #{mchId,jdbcType=VARCHAR}, ",
        "#{requestParams,jdbcType=VARCHAR}, #{requestDescribe,jdbcType=VARCHAR}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{requestStatus,jdbcType=VARCHAR}, ",
        "#{status,jdbcType=INTEGER}, #{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, ",
        "#{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(ApiRequestRecord record);

    @InsertProvider(type=ApiRequestRecordSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(ApiRequestRecord record);

    @SelectProvider(type=ApiRequestRecordSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="api_key", property="apiKey", jdbcType=JdbcType.VARCHAR),
        @Result(column="mch_id", property="mchId", jdbcType=JdbcType.VARCHAR),
        @Result(column="request_params", property="requestParams", jdbcType=JdbcType.VARCHAR),
        @Result(column="request_describe", property="requestDescribe", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="request_status", property="requestStatus", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<ApiRequestRecord> selectByExample(ApiRequestRecordExample example);

    @Select({
        "select",
        "id, api_key, mch_id, request_params, request_describe, create_time, request_status, ",
        "`status`, ext_1, ext_2, ext_3",
        "from api_request_record",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="api_key", property="apiKey", jdbcType=JdbcType.VARCHAR),
        @Result(column="mch_id", property="mchId", jdbcType=JdbcType.VARCHAR),
        @Result(column="request_params", property="requestParams", jdbcType=JdbcType.VARCHAR),
        @Result(column="request_describe", property="requestDescribe", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="request_status", property="requestStatus", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    ApiRequestRecord selectByPrimaryKey(Long id);

    @UpdateProvider(type=ApiRequestRecordSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") ApiRequestRecord record, @Param("example") ApiRequestRecordExample example);

    @UpdateProvider(type=ApiRequestRecordSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") ApiRequestRecord record, @Param("example") ApiRequestRecordExample example);

    @UpdateProvider(type=ApiRequestRecordSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(ApiRequestRecord record);

    @Update({
        "update api_request_record",
        "set api_key = #{apiKey,jdbcType=VARCHAR},",
          "mch_id = #{mchId,jdbcType=VARCHAR},",
          "request_params = #{requestParams,jdbcType=VARCHAR},",
          "request_describe = #{requestDescribe,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "request_status = #{requestStatus,jdbcType=VARCHAR},",
          "`status` = #{status,jdbcType=INTEGER},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(ApiRequestRecord record);
}